local Perl_Party_Events = {}
local thisid = nil;

----------------------
-- Loading Function --
----------------------

function Perl_Party_OnLoad()
	--Events
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");

	getglobal("Perl_party"..this:GetID().."_DropDown"):SetID(this:GetID());
	table.insert(UnitPopupFrames,"Perl_party"..this:GetID().."_DropDown");

	getglobal("Perl_party"..this:GetID().."_NameFrame_CastClickOverlay"):SetFrameLevel(getglobal("Perl_party"..this:GetID().."_StatsFrame"):GetFrameLevel() + 2);
	getglobal("Perl_party"..this:GetID().."_TargetFrame_TargetCastClickOverlay"):SetFrameLevel(getglobal("Perl_party"..this:GetID().."_StatsFrame"):GetFrameLevel() + 3);

	HidePartyFrame();
	ShowPartyFrame=NewShowPartyFrame;

	this.PlayerFlash = 0;
	this.time = 0;
	--this.forceBuffRefresh = 0;
	this.feigning = 0;
	this.partyid = "party"..this:GetID();

	Perl_InitFadeFrame(this);
end
function NewShowPartyFrame()
	return;
end

local function Perl_Party_RegisterSome()
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PARTY_LEADER_CHANGED");
	this:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
	this:RegisterEvent("UNIT_PVP_UPDATE");
	this:RegisterEvent("UNIT_DYNAMIC_FLAGS");
	this:RegisterEvent("UNIT_FLAGS");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
	--this:RegisterEvent("UNIT_SPELLMISS");
	Perl_RegisterBasics();
end
local function Perl_Party_UnregisterSome()
	this:UnregisterEvent("PARTY_MEMBERS_CHANGED");
	this:UnregisterEvent("PARTY_LEADER_CHANGED");
	this:UnregisterEvent("PARTY_LOOT_METHOD_CHANGED");
	this:UnregisterEvent("UNIT_PVP_UPDATE");
	this:UnregisterEvent("UNIT_DYNAMIC_FLAGS");
	this:UnregisterEvent("UNIT_FLAGS");
	this:UnregisterEvent("UNIT_AURA");
	this:UnregisterEvent("PARTY_MEMBER_ENABLE");
	this:UnregisterEvent("PARTY_MEMBER_DISABLE");
	--this:UnregisterEvent("UNIT_SPELLMISS");
	Perl_UnregisterBasics();
end

local function ShowHideValues(prefix)
	if (Perl_Config.ShowPartyValues == 1) then
        	getglobal(prefix.."_StatsFrame_HealthBar_HealthBarText"):Show();
        	getglobal(prefix.."_StatsFrame_ManaBar_ManaBarText"):Show();
	else
        	getglobal(prefix.."_StatsFrame_HealthBar_HealthBarText"):Hide();
        	getglobal(prefix.."_StatsFrame_ManaBar_ManaBarText"):Hide();
	end
end

local function Perl_Party_ShowPercentages(thisFrame)
	if (Perl_Config.ShowPartyPercent==1) then
		thisid = thisFrame:GetName();
		getglobal(thisid.."_StatsFrame"):SetWidth(136);
	end
	ShowHideValues(thisid);
end

local function Perl_Party_HidePercentages(thisFrame, argReason)
	thisid = thisFrame:GetName();
	getglobal(thisid.."_StatsFrame"):SetWidth(106);

	if (argReason) then
                getglobal(thisid.."_StatsFrame_HealthBar_HealthBarText"):SetText(argReason);
               	getglobal(thisid.."_StatsFrame_HealthBar_HealthBarText"):Show();
                getglobal(thisid.."_StatsFrame_ManaBar_ManaBarText"):Hide();
	else
		ShowHideValues(thisid);
	end

        getglobal(thisid.."_StatsFrame_HealthBar_HealthBarPercentText"):Hide();
        getglobal(thisid.."_StatsFrame_ManaBar_ManaBarPercentText"):Hide();
end

local function Perl_Party_UpdateHealth(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local numID = thisFrame:GetID();
		--partyid = ("party"..numID);
		thisid = thisFrame:GetName();
		local Partyhealth = UnitHealth(thisFrame.partyid);
		local Partyhealthmax = UnitHealthMax(thisFrame.partyid);
		local frameID = thisid.."_StatsFrame_"
		if ((thisFrame.feigning == 1) and (Partyhealth>1)) then
			thisFrame.feigning = 0;
		end
		if  (thisFrame.feigning == 1) then
	                getglobal(frameID.."HealthBar"):SetMinMaxValues(0, 1);
	                getglobal(frameID.."HealthBar"):SetValue(1);
	                --getglobal(frameID.."HealthBar"):SetStatusBarColor(Perl_Config.HealthBarColour.r,Perl_Config.HealthBarColour.g,Perl_Config.HealthBarColour.b);
		else
	                getglobal(frameID.."HealthBar"):SetMinMaxValues(0, Partyhealthmax);
	                getglobal(frameID.."HealthBar"):SetValue(Partyhealth);
		end
		Perl_SetSmoothBarColor(getglobal(frameID.."HealthBar"));
	        Perl_SetSmoothBarColor(getglobal(frameID.."HealthBarBG"),getglobal(frameID.."HealthBar"), 0.25);

		phealthPct = (Partyhealth * 100.0) / Partyhealthmax
		phealthPct = string.format("%3.0f", phealthPct);
	        getglobal(frameID.."HealthBar_HealthBarPercentText"):SetText(string.format("%d",(100*(Partyhealth / Partyhealthmax))+0.5).."%");
	        getglobal(frameID.."HealthBar_HealthBarPercentText"):Show();

		Perl_Party_ShowPercentages(thisFrame);

	        getglobal(frameID.."HealthBar_HealthBarText"):SetText(Partyhealth.."/"..Partyhealthmax);

		if (not UnitIsConnected(thisFrame.partyid)) then
			Perl_UnitAlive(thisFrame);
			Perl_Party_HidePercentages(thisFrame, "Offline");
			thisFrame:SetAlpha(Perl_Config.Transparency/2);
			getglobal("Perl_Party_Pet"..numID):SetAlpha(Perl_Config.Transparency/2);
		else
			thisFrame:SetAlpha(Perl_Config.Transparency);
			getglobal("Perl_Party_Pet"..numID):SetAlpha(Perl_Config.Transparency);

			if (thisFrame.feigning == 1) then
				Perl_UnitAlive(thisFrame);
				Perl_Party_HidePercentages(thisFrame, "Feign Death");

			elseif (UnitIsDead(thisFrame.partyid)) then
				Perl_UnitDied(thisFrame);
				Perl_Party_HidePercentages(thisFrame, "Dead");

			elseif (UnitIsGhost(thisFrame.partyid)) then
				Perl_UnitDied(thisFrame);
				Perl_Party_HidePercentages(thisFrame, "Ghost");

			elseif ((Partyhealth==1) and (Partyhealthmax==1)) then
				Perl_UnitAlive(thisFrame);
				Perl_Party_HidePercentages(thisFrame, "Updating");
			else
				Perl_UnitAlive(thisFrame);
			end
		end

		if (Perl_Config.ShowPartyPercent==0) then
	                getglobal(frameID.."ManaBar_ManaBarPercentText"):Hide();
	                getglobal(frameID.."HealthBar_HealthBarPercentText"):Hide();
			Perl_Party_HidePercentages(thisFrame);
		end
	end
end

--------------------
-- Buff Functions --
--------------------
local function Perl_Party_SetDebuffLoc(thisFrame)
	local debuff1 = getglobal(thisid.."_BuffFrame_DeBuff1");
        debuff1:ClearAllPoints();

	if (Perl_Config.PartyDebuffsBelow==0) then
		if ((getglobal("Perl_Party_Pet"..thisFrame:GetID())):IsVisible()) then
                        debuff1:SetPoint("LEFT", "Perl_Party_Pet"..thisFrame:GetID().."_StatsFrame", "RIGHT", 0, 0);
		else
                        debuff1:SetPoint("LEFT", "Perl_party"..thisFrame:GetID().."_StatsFrame", "RIGHT", 0, 0);
		end
	else
                debuff1:SetPoint("TOPLEFT", ("Perl_party"..thisFrame:GetID().."_BuffFrame_Buff1"), "BOTTOMLEFT", 0, -2);
	end
end

local function Perl_Party_Buff_UpdateAll(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		if (Perl_Config.PartyBuffs == 0 and Perl_Config.PartyDebuffs == 0) then
			getglobal(thisFrame:GetName().."_BuffFrame"):Hide();
		else
			getglobal(thisFrame:GetName().."_BuffFrame"):Show();

			thisid = thisFrame:GetName();
			if (UnitName(thisFrame.partyid)) then
				local needUpdateHealth = false;
				Perl_Party_SetDebuffLoc(thisFrame);

				for buffnum=1,10 do
	        	                local button = getglobal(thisid.."_BuffFrame_Buff"..buffnum);

					if (Perl_Config.PartyBuffs == 1) then
						local icon = getglobal(button:GetName().."Icon");
						local buff, count = UnitBuff(thisFrame.partyid, buffnum);
						if (buff) then
							icon:SetTexture(buff);
							if (strfind(strlower(buff), "feigndeath")) then
								if (thisFrame.feigning == 0) then
									thisFrame.feigning = 1;
									needUpdateHealth = true;
								end
							end
							local buffCount = getglobal(thisid.."_BuffFrame_Buff"..buffnum.."Count");
							if (count > 1) then
								buffCount:SetText(count);
								buffCount:Show();
							else
								buffCount:Hide();
							end
							button:Show();
						else
							button:Hide();
						end
					else
						button:Hide();
					end
				end

				for buffnum=1,8 do
	        	                local button = getglobal(thisid.."_BuffFrame_DeBuff"..(buffnum));

					if (Perl_Config.PartyDebuffs == 1) then
						local buff, count, debuffType = UnitDebuff(thisFrame.partyid, buffnum);
						if (buff) then
							local icon = getglobal(button:GetName().."Icon");
							icon:SetTexture(buff);

							local buffCount = getglobal(thisid.."_BuffFrame_DeBuff"..buffnum.."Count");
							if (count > 1) then
								buffCount:SetText(count);
								buffCount:Show();
							else
								buffCount:Hide();
							end

							local borderColor = DebuffTypeColor[(debuffType or "none")];
							local buffBorder = getglobal(thisid.."_BuffFrame_DeBuff"..buffnum.."Border");
							buffBorder:SetVertexColor(borderColor.r, borderColor.g, borderColor.b);

							button:Show();
						else
							button:Hide();
						end
					else
						button:Hide();
					end
				end

				if (needUpdateHealth) then
					Perl_Party_UpdateHealth();
				end
			end
		end
	end

	Perl_CheckDebuffs(thisFrame.partyid, {getglobal(thisFrame:GetName().."_NameFrame"),getglobal(thisFrame:GetName().."_LevelFrame"),getglobal(thisFrame:GetName().."_StatsFrame")});
end

function Perl_Party_SetBuffTooltip ()
	local partyid = "party"..this:GetParent():GetParent():GetID();
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT",30,0);
	GameTooltip:SetUnitBuff(partyid, this:GetID());
	Perl_ToolTip_AddBuffDuration(partyid);
end

local function GetNamesWithoutBuff(tex)
	local names;
	for i = 1,GetNumRaidMembers() do
		local name = UnitName("raid"..i);
		if (name) then
			local hasBuff = false;
			for num = 1,25 do
				local buffTexture = UnitBuff("raid"..i, num);
				if (not buffTexture) then
					break;
				end

				if (buffTexture == tex) then
					hasBuff = true;
					break;
				end
			end

			if (not hasBuff) then
				local _, class = UnitClass("raid"..i);
				if (class) then
					names = (names or "").." "..PerlColourTable[class]..name;
				else
					names = (names or "").." "..name;
				end
			end
		end
	end

	return names;
end

function Perl_ToolTip_AddBuffDuration(partyid)
	if (UnitName("raid1") and GameTooltip:IsOwned(this)) then
	 	if (CT_RA_Stats) then
			local unitStats = CT_RA_Stats[UnitName(partyid)];
			if (unitStats) then
				local unitBuffs = unitStats["Buffs"];
				if (unitBuffs) then
					local buffName = getglobal("GameTooltipTextLeft1");
					if (buffName) then
						buffName = buffName:GetText();
						local buff = unitBuffs[buffName];

						if (buff) then
							if (buff[2] and buff[2] > 0) then
								if (partyid ~= "player") then
									GameTooltip:AddLine(SecondsToTime(buff[2], true).."remaining", 1, 0.82, 0);
								end

								GameTooltip:Show();
								--return;
							end
						end
					end
				end
			end
		end

		local icon = getglobal(this:GetName().."Icon");
		if (icon) then
			local tex = icon:GetTexture();
			if (tex) then
				local names = GetNamesWithoutBuff(tex);
				if (names) then
					GameTooltip:AddLine("Without buff:", 1, 0.3, 0.1);
					GameTooltip:AddLine(names, 0.8, 0.5, 0.4, 1);
					GameTooltip:Show();
				end
			end
		end
	end
end

function Perl_Party_SetDeBuffTooltip ()
	local partyid = "party"..this:GetParent():GetParent():GetID();
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT",30,0);
	GameTooltip:SetUnitDebuff(partyid, this:GetID());
	Perl_ToolTip_AddDebuffDuration(partyid);
end

function Perl_ToolTip_AddDebuffDuration(partyid)
	if (CT_RA_Stats) then
		local unitStats = CT_RA_Stats[UnitName(partyid)];
		if (unitStats) then
			local unitDebuffs = unitStats["Debuffs"];
			if (unitDebuffs) then
				local buffName = getglobal("GameTooltipTextLeft1");
				if (buffName) then
					buffName = buffName:GetText();
					local buff = unitDebuffs[buffName];

					if (buff) then
						if (buff[2] and buff[2] > 0) then
							GameTooltip:AddLine(SecondsToTime(buff[2], true).."remaining", 1, 0.82, 0);
							GameTooltip:Show();
							return;
						end
					end
				end
			end
		end
	end
end


-------------------------
-- The Update Function --
-------------------------
local function Perl_Party_CombatFlash(elapsed, argNew, argGreen)
	if (Perl_CombatFlashSet (elapsed, this, argNew, argGreen)) then
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_NameFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_LevelFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_StatsFrame"), this.PlayerFlash, this.PlayerFlashGreen);
	end
end

-- Perl_ColourFriendlyUnit
function Perl_ColourFriendlyUnit(frame, partyid)
	if (UnitIsEnemy("player", partyid)) then	-- For dueling
                frame:SetTextColor(1,0,0);
	else
		if (Perl_Config.ClassColouredNames == 1) then
			local _, engClass = UnitClass(partyid);
			local r, g, b = Perl_GetClassColour(engClass);
			frame:SetTextColor(r, g, b, Perl_Config.TextTransparency);
		else
			if (UnitIsPVP(partyid)) then
                	        frame:SetTextColor(0,1,0);
			else
                	        frame:SetTextColor(0.5,0.5,1);
			end
		end
	end
end

local function Perl_Party_UpdateName(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		thisid = thisFrame:GetName();
		local Partyname = UnitName(thisFrame.partyid);
		if (Partyname) then
			local frame = getglobal(thisid.."_NameFrame_NameBarText");

			if (strlen(Partyname) > 40) then
				Partyname = strsub(Partyname, 1, 39).."...";
			end
        	        if (Perl_Config.ShowPartyNames==1) then
				getglobal(thisid.."_NameFrame"):Show();
			end
        	        frame:SetText(Partyname);

			Perl_ColourFriendlyUnit(frame, thisFrame.partyid);
		end
	end
end

local function Perl_Party_UpdateLeader(idf)
	local thisFrame;
	if (idf == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..idf);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		local id = thisFrame:GetID();
	        local icon = getglobal(thisid.."_NameFrame_LeaderIcon");
		if (GetPartyLeaderIndex() == id ) then
			icon:Show();
		else
			icon:Hide();
		end
	        icon = getglobal(thisid.."_NameFrame_MasterIcon");
		local lootMethod;
		local lootMaster;
		lootMethod, lootMaster = GetLootMethod();
		if ( id == lootMaster ) then
			icon:Show();
		else
			icon:Hide();
		end
	end
end

local function Perl_Party_Update_Control(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
	        if (UnitIsVisible(thisFrame.partyid) and UnitIsCharmed(thisFrame.partyid)) then
			--Perl_Target_Warning:SetTexture("Interface\Minimap\Ping\ping6");
			--Perl_Target_Warning:SetBlendMode("ADD");
			getglobal(thisFrame:GetName().."_NameFrame_Warning"):Show();
		else
			getglobal(thisFrame:GetName().."_NameFrame_Warning"):Hide();
		end
	end
end

function Perl_Party_UpdateCombat(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
	        Perl_Party_UpdateCombat1(thisFrame.partyid, thisFrame:GetName());
		Perl_Party_UpdateTarget();
		Perl_Party_Update_Control();
	end
end

function Perl_Party_UpdateCombat1(argID,argName)
	local frame = getglobal(argName.."_NameFrame_ActivityStatus");
	if (not (frame == nil)) then
	        if (UnitName(argID) and UnitAffectingCombat(argID)) then
	                frame:Show();
		else
	                frame:Hide();
		end
	end
end

local function Perl_Party_UpdatePVP(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local f = getglobal(thisFrame:GetName().."_NameFrame_PVPStatus");
		if (UnitIsPVP(thisFrame.partyid)) then
			f:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..(UnitFactionGroup(thisFrame.partyid) or "FFA"));
	                f:Show();
		else
	                f:Hide();
		end
	end
end

local function Perl_Party_UpdateLevel(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		local Partylevel = UnitLevel(thisFrame.partyid);
		local color = GetDifficultyColor(Partylevel);
	        getglobal(thisid.."_LevelFrame_LevelBarText"):SetTextColor(color.r,color.g,color.b);
	        getglobal(thisid.."_LevelFrame_LevelBarText"):SetText(Partylevel);
	end
end

local function Perl_Party_UpdateClass(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		if (UnitIsPlayer(thisFrame.partyid)) then
			local _, PlayerClass = UnitClass(thisFrame.partyid);
			local r, l, t, b = Perl_ClassPos(PlayerClass);
			getglobal(thisid.."_LevelFrame_ClassTexture"):SetTexCoord(r, l, t, b);
		end

		if (Perl_Config.ShowPartyClassIcon==1) then
	                getglobal(thisid.."_LevelFrame_ClassTexture"):Show();
		else
	                getglobal(thisid.."_LevelFrame_ClassTexture"):Hide();
		end
	end
end

local function Perl_Party_UpdateManaType(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local frameName = thisFrame:GetName().."_StatsFrame_ManaBar";
		Perl_SetManaBarType(thisFrame.partyid, getglobal(frameName), getglobal(frameName.."BG"));
	end
end

local function Perl_Party_UpdateMana(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		local Partymana = UnitMana(thisFrame.partyid);
		local Partymanamax = UnitManaMax(thisFrame.partyid);
		local frameManaBar = getglobal(thisid.."_StatsFrame_ManaBar");
		local frameManaBarText = getglobal(thisid.."_StatsFrame_ManaBar_ManaBarText");
		local frameManaBarPercentText = getglobal(thisid.."_StatsFrame_ManaBar_ManaBarPercentText");
		local frameHealthBarPercentText = getglobal(thisid.."_StatsFrame_HealthBar_HealthBarPercentText");

		if (Partymanamax == 1 and Partymana > Partymanamax) then
			Partymanamax = Partymana;
		end

	        frameManaBar:SetMinMaxValues(0, Partymanamax);
	        frameManaBar:SetValue(Partymana);
		pmanaPct = (Partymana * 100.0) / Partymanamax
		pmanaPct =  string.format("%3.0f", pmanaPct);
	        if (frameHealthBarPercentText:IsVisible()) then
			frameManaBarPercentText:Show();
		end
		if (UnitPowerType(thisFrame.partyid)>=1) then
	                frameManaBarPercentText:SetText(Partymana);
		else
	                frameManaBarPercentText:SetText(string.format("%d",(100*(Partymana / Partymanamax))+0.5).."%");
		end

		if (Perl_Config.ShowPartyValues == 1) then
	        	frameManaBarText:Show();
		else
	        	frameManaBarText:Hide();
		end

	        frameManaBarText:SetText(Partymana.."/"..Partymanamax);
		if (Perl_Config.ShowPartyPercent==0) then
	                frameManaBarPercentText:Hide();
	                frameHealthBarPercentText:Hide();
	                getglobal(thisid.."_StatsFrame"):SetWidth(106);
		end
		if (UnitIsConnected(thisFrame.partyid)) then
			thisFrame:SetAlpha(Perl_Config.Transparency);
			getglobal("Perl_Party_Pet"..thisFrame:GetID()):SetAlpha(Perl_Config.Transparency);
		else
			thisFrame:SetAlpha(Perl_Config.Transparency/2);
			getglobal("Perl_Party_Pet"..thisFrame:GetID()):SetAlpha(Perl_Config.Transparency/2);
	                getglobal(thisid.."_StatsFrame_HealthBar_HealthBarText"):SetText("Offine");
		end
	end
end

function Perl_Party_OnUpdate(elapsed)
        if (CastPartyConfig and (Perl_Config.CastPartyShow==0)) then
		if (CastPartyMainFrame) then
			CastPartyMainFrame:Hide();
		end
		if (CastPartyFrame0 and CastPartyFrame1 and CastPartyFrame2) then
			CastPartyFrame0:Hide();
			CastPartyFrame1:Hide();
			CastPartyFrame2:Hide();
		end
	end

	if elapsed then
		thisid = this:GetName();
		--partyid = ("party"..id);

		Perl_Party_CombatFlash(elapsed, false);

		--this.time = elapsed + this.time;
		--if this.time >= 0.2 then
		--	Perl_Party_UpdateCombat();
		--	this.time=0;
		--end
	end

	Perl_UnitDeathSequence();
	Perl_ProcessFade(this);
end

local function Perl_Party_StartFade(thisFrame)
	local framePet = getglobal("Perl_Party_Pet"..thisFrame:GetID());
	if (framePet:IsVisible()) then
		Perl_StartFade(framePet);
	end
	Perl_StartFade(thisFrame);

	if (UnitName(thisFrame.partyid) and not UnitIsConnected(thisFrame.partyid)) then
		thisFrame.FadeTime = 0.5;
		if (framePet:IsVisible()) then
			framePet.FadeTime = 0.5;
		end
	end
end

function Perl_Party_UpdateDisplay(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		if (UnitName(thisFrame.partyid)) then
			Perl_CancelFade(thisFrame);

			Perl_Party_UpdateName(id);
			Perl_Party_UpdateLeader(id);
			Perl_Party_UpdatePVP(id);
			Perl_Party_UpdateClass(id);
			Perl_Party_UpdateManaType(id);
			Perl_Party_UpdateHealth(id);
			Perl_Party_UpdateMana(id);
			Perl_Party_UpdateLevel(id);
        	        Perl_Party_UpdateCombat(id);
			Perl_Party_Buff_UpdateAll(id);

			if (UnitName("raid1")) then
				if (Perl_Config.ShowPartyRaid==1) then
					thisFrame:Show();
				elseif (Perl_Config.ShowPartyRaid == 0) then
					Perl_Party_StartFade(thisFrame);
				end
			else
				thisFrame:Show();
			end

		else
			Perl_Party_StartFade(thisFrame);
		end
	end
end

--------------------
-- Click Handlers --
--------------------
-- Non local by request (GenesisClicks/Elsewhere)
function Perl_Party_FindID(object)
	local _, _, num = string.find(object:GetName(), "(%d+)");
	return tonumber(num);
end

local function Perl_PartyDropDown_Initialize()
	local dropdown;
	local id = this:GetID();

	if (id == 0) then
		id = string.sub(this:GetName(), 11, 11);
	end

	if ( UIDROPDOWNMENU_OPEN_MENU ) then
		dropdown = getglobal(UIDROPDOWNMENU_OPEN_MENU);
	else
		dropdown = this;
	end

	UnitPopup_ShowMenu(dropdown, "PARTY", "party"..id);
end

function Perl_PartyDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, Perl_PartyDropDown_Initialize, "MENU");
end

function Perl_Party_OnClick(button,argTarget)
	local id=Perl_Party_FindID(this);
	this:SetID(id);
	local unit = "party"..id;

	if (argTarget == 1) then
		unit = unit.."target";
	end

	if (type(Perl_CustomClickFunction) == "function") then
		if (Perl_CustomClickFunction(button, unit)) then
			return;
		end
	end

	if (Perl_Config.CastParty == 1 and CastParty_OnClickByUnit) then
		CastParty_OnClickByUnit(button, unit);
	else
		if ( SpellIsTargeting() and button == "RightButton" ) then
			SpellStopTargeting();
			return;
		end
		if ( button == "LeftButton" ) then
			if ( SpellIsTargeting() ) then
				SpellTargetUnit(unit);
			elseif ( CursorHasItem() ) then
				DropItemOnUnit(unit);
			else
				TargetUnit(unit);
			end
		else
			if (argTarget == 0) then
				ToggleDropDownMenu(1, nil, getglobal("Perl_party"..id.."_DropDown"), this:GetName(), 0, 0);
			end
		end
	end
end

function Perl_Party_PlayerTip(argTarget)
        Perl_Options_SelectFrame("party");

	local id=Perl_Party_FindID(this);
	--GameTooltip_SetDefaultAnchor(GameTooltip, this);
	--GameTooltip:SetUnit("party"..id);

	local unitid = "party"..id;
	if (argTarget) then
		unitid = unitid.."target";
	end

	Perl_PlayerTip(unitid);
end

function Perl_Party_UpdateTarget(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and not thisFrame.Fading and thisFrame.partyid) then
		--local partyid = "party"..this:GetID();
		local frame = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame");

		if (frame == nil) then
			return
		end
		if (frame.Fading == 1) then
			return;
		end

		if (Perl_Config.ShowPartyTarget == 0) then
			frame:SetWidth(68);
			frame:Hide();
			return;
		end

		local frameText = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame_Target");
		if (UnitIsConnected(thisFrame.partyid) and UnitName(thisFrame.partyid) and UnitIsVisible(thisFrame.partyid)) then
			local unit = thisFrame.partyid.."target";

			if (UnitExists (unit)) then
				local targetname = UnitName(unit);
				frameText:SetText(targetname);
				local width = frameText:GetStringWidth();

				if (width < 68) then
					frame:SetWidth(68);
				elseif (width > 112) then
					frame:SetWidth(120);

					local remCount = 1;
					while ((frameText:GetStringWidth() >= 112) and (string.len(targetname) > remCount)) do
						targetname = string.sub(targetname, 1, string.len(targetname) - remCount).."..";
						remCount = 3;
						frameText:SetText(targetname);
					end
				else
					frame:SetWidth(width + 8);
				end

				Perl_SetUnitNameColor (unit, frameText);
				frame:Show();
				frame:SetAlpha(Perl_Config.Transparency);

				local frameAct = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame_TargetActivityStatus");
			        if (UnitAffectingCombat(unit)) then
			                frameAct:SetTexCoord(0.5, 1.0, 0.0, 0.5);
			                frameAct:Show();
				else
			                frameAct:Hide();
				end

				local framePVP = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame_TargetPVPStatus");
				if (UnitIsPVP(unit)) then
					framePVP:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..(UnitFactionGroup(unit) or "FFA"));
					framePVP:Show();
				else
					framePVP:Hide();
				end
			else
				frame:SetWidth(68);
				frame:SetAlpha(0);
				--frame:Hide();
			end
		else
			frame:SetWidth(68);
			frame:SetAlpha(0);
			--frame:Hide();
		end
	end
end

-------------------
-- Event Handler --
-------------------
function Perl_Party_OnEvent()
	local func = Perl_Party_Events[event];
	if (func) then
		func();
	else
Perl_ShowMessage("EXTRA EVENT");
		--Perl_Party_UpdateDisplay();
	end
end

-- PLAYER_ENTERING_WORLD
function Perl_Party_Events:PLAYER_ENTERING_WORLD()
	Perl_Party_RegisterSome();
	Perl_Party_UpdateDisplay();
end
Perl_Party_Events.PARTY_MEMBERS_CHANGED		= Perl_Party_Events.PLAYER_ENTERING_WORLD;

-- PLAYER_LEAVING_WORLD()
function Perl_Party_Events:PLAYER_LEAVING_WORLD()
	Perl_Party_UnregisterSome();
end

-- PARTY_LEADER_CHANGED
function Perl_Party_Events:PARTY_LEADER_CHANGED()
	Perl_Party_UpdateLeader();
end

Perl_Party_Events.PARTY_LOOT_METHOD_CHANGED	= Perl_Party_Events.PARTY_LEADER_CHANGED;

-- UNIT_COMBAT
function Perl_Party_Events:UNIT_COMBAT()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateCombat();

		if (arg2 == "HEAL") then
			Perl_Party_CombatFlash(0, true, true);
		elseif (arg4 and arg4 > 0) then
			Perl_Party_CombatFlash(0, true);
		end
	end
end

-- UNIT_SPELLMISS
--function Perl_Party_Events:UNIT_SPELLMISS()
--	if (arg1 == this.partyid) then
--		Perl_Party_UpdateCombat();
--	end
--end

-- UNIT_HEALTH, UNIT_MAXHEALTH
function Perl_Party_Events:UNIT_HEALTH()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateHealth();
	end
end

-- UNIT_MAXHEALTH
function Perl_Party_Events:UNIT_MAXHEALTH()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateHealth();
		Perl_Party_UpdateLevel();	-- Level not available until we've received maxhealth
	end
end

Perl_Party_Events.PARTY_MEMBER_ENABLE	= Perl_Party_Events.UNIT_HEALTH;
Perl_Party_Events.PARTY_MEMBER_DISABLE	= Perl_Party_Events.UNIT_HEALTH;

-- UNIT_MANA
function Perl_Party_Events:UNIT_MANA()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateMana();
        	--Perl_Party_UpdateCombat();
	end
end

Perl_Party_Events.UNIT_MAXMANA		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_RAGE		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXRAGE		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_ENERGY		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXENERGY	= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_FOCUS		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXFOCUS		= Perl_Party_Events.UNIT_MANA;

-- UNIT_DISPLAYPOWER
function Perl_Party_Events:UNIT_DISPLAYPOWER()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateManaType();
		Perl_Party_UpdateMana();
	end
end

-- UNIT_NAME_UPDATE
function Perl_Party_Events:UNIT_NAME_UPDATE()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateName();
	end
end

-- UNIT_LEVEL
function Perl_Party_Events:UNIT_LEVEL()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateLevel();
	end
end

-- UNIT_AURA
function Perl_Party_Events:UNIT_AURA()
	if (arg1 == this.partyid) then
		Perl_Party_Buff_UpdateAll();
		--Perl_Party_UpdateCombat();
	end
end

-- UNIT_PVP_UPDATE
function Perl_Party_Events:UNIT_PVP_UPDATE()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateName();
		Perl_Party_UpdatePVP();
		Perl_Party_UpdateCombat();
	end
end

Perl_Party_Events.UNIT_FLAGS = Perl_Party_Events.UNIT_PVP_UPDATE;
Perl_Party_Events.UNIT_DYNAMIC_FLAGS = Perl_Party_Events.UNIT_PVP_UPDATE;

-- Moving stuff
function Perl_Party_GetGap()
	local a = Perl_party1:GetBottom() - Perl_party2:GetTop();

	a = a + 0.01;
	a = a * 100;
	a = math.floor (a);
	a = a / 100;

	return (math.floor(a));
end

function Perl_Party_SetGap(newGap)
	if (type(newGap) == "number") then
		for i = 2,4 do
			local frame1 = getglobal("Perl_party"..(i - 1));
			local frame2 = getglobal("Perl_party"..i);

			local left1 = frame1:GetLeft();
			local left2 = frame2:GetLeft();

			frame2:ClearAllPoints();
			frame2:SetPoint("TOPLEFT", frame1, "BOTTOMLEFT", (left2 - left1), -newGap);
		end
	end
end

function Perl_Party_AlignLeft()
	for i = 2,4 do
		local frame1 = getglobal("Perl_party"..(i - 1));
		local frame2 = getglobal("Perl_party"..i);

		local gap = frame1:GetBottom() - frame2:GetTop();

		frame2:ClearAllPoints();
		frame2:SetPoint("TOPLEFT", frame1, "BOTTOMLEFT", 0, -gap);
	end
end
